#Look inot anchors
stages:
  - build
  - test
  - deploy review
  - deploy staging
  - deploy production
  - production tests

cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - node_modules/
      
image: node:latest

variables:
  STAGING_DOMAIN: ceciestunnomdedomainequejespereetrealeatoirestaging.surge.sh
  PRODUCTION_DOMAIN: ceciestunnomdedomainequejespereetrealeatoire.surge.sh

build website:
  stage: build
  script:
    - echo $CI_COMMIT_SHORT_SHA
    - npm install
    - npm install -g gatsby-cli
    - gatsby build
    - sed -i "s/%%VERSION%%/$CI_COMMIT_SHORT_SHA/" ./public/index.html
  artifacts:
    paths:
      - ./public
      
test artifact:
  image: alpine
  stage: test
  script:
    - grep -q "Gatsby" ./public/index.html

test website:
  stage: test
  script:
    - npm install
    - npm install -g gatsby-cli
    - gatsby serve & 
    - sleep 3
    - curl "http://localhost:9000" | tac | tac | grep -q "Gatsby"

deploy review:
  stage: deploy review
  only:
    - merge_request
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://ceciestunurlaleatoire-$CI_ENVIRONMENT_SLUG.surge.sh
  script:
    - npm install --global surge
    - surge --project ./public --domain ceciestunurlaleatoire-$CI_ENVIRONMENT_SLUG.surge.sh

deploy staging:
  stage: deploy staging
  environment:
    name: staging
    url: http://$STAGING_DOMAIN
  only:
    - master
  script:
    - npm install --global surge
    - surge --project ./public --domain $STAGING_DOMAIN

deploy production:
  stage: deploy production
  environment:
    name: production
    url: http://$PRODUCTION_DOMAIN
  when: manual
  only: 
    - master
  allow_failure: false
  script:
    - npm install --global surge
    - surge --project ./public --domain $PRODUCTION_DOMAIN
    
production tests:
  image: alpine
  stage: production tests
  only:
    - merge-request
  script:
    - apk add --no-cache curl
    - curl -s "https://ceciestunnomdedomainequejespereetrealeatoire.surhe.sh" | grep -q "Hi people"
    - curl -s "https://ceciestunnomdedomainequejespereetrealeatoire.surhe.sh" | grep -q "$CI_COMMIT_SHORT_SHA"